/**************************************/
/* midi.h -- Multimedia for emx 1.2   */
/*                                    */
/*                                    */
/* Darwin O'Connor 1999-12            */
/*                                    */
/**************************************/

#ifndef _MIDI_H
#define _MIDI_H

/* use 8-bit alignment */
#pragma pack(1)


/***************/
/* definitions */
/***************/

#define STATUS_BIT 0x80

#define TRACK_OFF 0
#define TRACK_ON 1

#define NORMAL_SYSEX 0xF0
#define ESCAPE_SYSEX 0xF7
#define META 0xFF

#define MMIO_SEQ MMIOM_USER+1
#define MMIO_MERGE MMIOM_USER+2
#define MMIO_FROM_SEQ MMIOM_USER+3
#define MMIO_TIMED_READ MMIOM_USER+4
#define MMIO_SET_TRACKS MMIOM_USER+5
#define MMIO_FORMAT_0 MMIOM_USER+6
#define MMIO_GETHEADER MMIOM_GETHEADER
#define MMIOM_GETFILELENGTH MMIOM_USER+10
#define MMIOM_GETTRACKLENGTH MMIOM_USER+11

/************/
/* typedefs */
/************/

typedef struct _MIDIHEADER {
    CHAR chHeaderChunk[4];
    ULONG ulHeaderLength;
    USHORT usFormat;
    USHORT usNumTracks;
    USHORT usDivision;
    PVOID vpAdditionalInformation;
} MIDIHEADER;

typedef struct _MMMIDIHEADER {
    ULONG ulHeaderLength;
    ULONG ulContentType;
    ULONG ulMediaType;
    MIDIHEADER midiheader;
} MMMIDIHEADER;

typedef MMMIDIHEADER *PMMMIDIHEADER;

/* set default alignment */
#pragma pack()

/* nested header management */
#endif

